<?php
/*
    TMS RESTful API

    This script provides a RESTful API interface for web application accessing
    Tailor Made Software Conversion and Data Extraction engines


   Input:
        $_GET  = JSON (jsonp)formatted request according to TMS REST Api specification
		alternatively the content directly posted to the RESTful API, JSON formatted,

    Output: A formatted JSON HTTP response according to TME REST Api specification


    History:
		May 30          2016  - Version 1.4.05   - added external configuration file, infrastructure for calling through CV-JS
		Aug 12          2016  - Version 1.4.06   - updated for autoxchange defined through symbolic links
		Sep 11          2016  - Version 1.4.07   - minor additions
		Oct 18-20       2016  - Version 1.4.08   - modifications to config, ability to do conversions via POST

*/

	require 'call-Api_08_ax2_config.php';


	$add_xpath = true;  // we are adding xpath

	// we are setting the callback identifier to match the one defined in the originating document
	// 2016-01-28

	if ($debug)	echo "before _ isset()x2 ";

	$post_request_flag = false;

    $callback ='tms_restful_api';
	$json_data = "";

    if(!empty($_GET['tms_restful_api']))
    {

		if ($debug)	echo "_GET['tms_restful_api'] is set ";

        $callback = $_GET['tms_restful_api'];
		$json_data = $_GET['json'];

		if (empty($json_data)){
			$wrong_post_format = 1;
			$error_response = "{\"completedAction\":\"none\",\"errorCode\":\" \POST variable $_POST[request] is not defined \"}";
			//echo $error_response;
			// 2016-01-28 changed to be wrapped in return method
			echo $callback.'(' . json_encode($error_response) . ')';
			exit;
		}

    }


    if(!empty($_POST['json_data']))
    {

		if ($debug)	echo "_POST['json_data'] is set ";

        $callback = "";
		$json_data = $_POST['json_data'];
		$post_request_flag = true;

		if (empty($json_data)){
			$wrong_post_format = 1;
			$error_response = "{\"completedAction\":\"none\",\"errorCode\":\" \POST variable $_POST[request] is not defined \"}";
			//echo $error_response;
			// 2016-01-28 changed to be wrapped in return method
			echo $callback.'(' . json_encode($error_response) . ')';
			exit;
		}
    }


	$demo_mode = FALSE;

	// we are setting the authentication success to true
	$authentication_success = TRUE;

	//$stream_response_cgi= $httpHost . '/' . $callbackMethod ;
	$stream_response_cgi= $httpPhpUrl . '/' . $callbackMethod ;





	// this will be overwritten with _config file value
	$ld_lib_path = "/home/cadviewer/tms-restful-api/lib";


if ($debug)	echo " first in file ";


	$wrong_post_format = 0;
	$error_response = "{
									\"completedAction\":\"none\",
									\"errorCode\":\"incorrect formated http POST / JSON \"
									}";


if ($debug)	echo "\$json_data: $json_data\n";

	// parse the _POST call / content retrieved from file_get_content

	$json_request = json_decode($json_data, true);


	if (empty($json_request)){

		$wrong_post_format = 1;
		$error_response = "{
										\"completedAction\":\"none\",
										\"errorCode\":\" JSON string expression incorrectly formatted \"
										}";
		//echo $error_response;


		// 2016-01-28    changed to be wrapped into callback method for jasonp

		// if jsonp then prepend callback, if standard post do not
		if ($post_request_flag)
			echo json_encode($error_response) ;
		else
			echo $callback.'(' . json_encode($error_response) . ')';

	}


	try {
		$delete_folder_status = isset($json_request['action']);
		if ($delete_folder_status){
			if ($json_request['action'] == 'clear_files_folder' ) {
				$files = glob($fileLocation.'*'); // get all file names
				foreach($files as $file){ // iterate files
			  		if (is_file($file))
			    		unlink($file); // delete file
				}
				echo "Files deleted! ";
				exit;
			}
		}
	} catch (Exception $e) {
		// none
	}





	$temp_var = "";
	try {

		$conv_status = isset($json_request['converters']);
		if ($conv_status) $temp_var = $json_request['converters'];
	} catch (Exception $e) {

	}


if ($debug)	echo "\$json_request(conv): $temp_var\n";
//	echo "\$json_request: $json_request\n";


	$general_response= "{ \"error\": [] }";


//  list over available engines
	$engine_response=
"{\"installedEngines\":[
{\"converter\":\"AutoXchange AX2015\",\"version\":\"V2.00\",\"status\":\"active\"},
{\"converter\":\"AutoXchange AX2011\",\"version\":\"V2.00\",\"status\":\"active\"}]}";


	$engine_listing = [
		"internalListInstalledEngines" => [
			[
				"converter" => "AutoXchange AX2015",
				"version" => "V2.00",
				"executable" => $ax2015_executable,
				"location" => $converterLocation,
				"axpathExeOnly" => $converterLocation . "ax2011/" . $ax2011_executable ,
				"status" => "active"
			],
			[
				"converter" => "AutoXchange AX2015 DEMO",
				"version" => "V2.00",
				"executable" => $ax2015_executable,
				"location" => $converterLocation . "ax2011/" . $ax2011_executable,
				"axpathExeOnly" => "ax2015.exe",
				"status" => "active"
			],
			[
				"converter" => "AutoXchange AX2011",
				"version" => "V2.00",
				"executable" =>  $ax2011_executable ,
				"location" => $converterLocation . "ax2011/",
				"axpathExeOnly" => "",
				"status" => "active"
			],
			[
				"converter" => "AutoXchange AX2011 DEMO",
				"version" => "V2.00",
				"executable" => $ax2015_executable,
				"location" => $converterLocation . "ax2011",
				"axpathExeOnly" => "",
				"status" => "active"
			]
		]
	];

	$converter_list = $engine_listing['internalListInstalledEngines'];


	// template for conversion/data extraction response
	$conversion_response_template = "{
									\"completedAction\":\"xxx\",
									\"errorCode\":\"xxx\",
									\"converter\":\"V2.00\",
									\"version\":\"xxx\",
									\"userLabel\":\"xxx\",
									\"contentLocation\":\"xxx\"
									}";

	$conversion_response = json_decode($conversion_response_template, true);



	try {
		$conv_status = isset($json_request['converters']);

		if ($conv_status){
			if ($json_request['converters'] == 'listInstalledEngines' ) {
				$general_response = $engine_response;
			}
		}
	} catch (Exception $e) {
		// none
	}



	if ($json_request['action'] == 'conversion' ||  $json_request['action'] == 'data_extraction' || $json_request['action'] == 'svg_js_creation_cvheadless' || $json_request['action'] == 'svg_js_creation' ) {

		$converter = $json_request['converter'];
		$version = $json_request['version'];
		$contenttype = $json_request['contentType'];


		if (isset($json_request['contentLocation']))
			$contentlocation = $json_request['contentLocation'];
		if (isset($json_request['embeddedContent']))
			$embeddedcontent = $json_request['embeddedContent'];
		if (isset($json_request['contentStream']))
			$contentstream = $json_request['contentStream'];


		$contentresponse = $json_request['contentResponse'];
		$contentformat = $json_request['contentFormat'];
		$userlabel = $json_request['userLabel'];
		$parameters = $json_request['parameters'];


		$contentusername = $json_request['contentUsername'];
		$contentpassword = $json_request['contentPassword'];

		// make a loop over parameters, create the proper parameter format for exec()
		$param_string = "";
		$param_string_painter = "";

		$max = sizeof($parameters);
		$output_file_extension = "txt";

//echo "\$max: $max\n";
		for ($i = 0; $i < $max; $i++) {
			if ($parameters[$i]['paramName'] != ''){
				if ($parameters[$i]['paramValue'] != ''){
					// there is both a param and a value

					if (( $converter == 'xxLinkList-XML LL2014' && $parameters[$i]['paramName']== 'f' && $parameters[$i]['paramValue'] == 'xml')
					  || ($converter == 'xxLinkList-XML LL2014' && $parameters[$i]['paramName']== 'f' && $parameters[$i]['paramValue'] == 'XML')){

					  		// 2016-01-26  : assuming this issue fixed, therefore blocks this branch, will test this case
					  		// make this a general "sidebranch"


					  		// do nothing LinkList-XML 2014 cannot parse -f=xml  (bug in current converter release)
					  }
					  else{

						// here we check if for the f parameters in case of svg_js_creation_cvheadless
						if ($converter == 'AutoXchange AX2011' && $parameters[$i]['paramName']== 'f' && $json_request['action'] == 'svg_js_creation_cvheadless'){

							$param_string = $param_string . " -" . 'f' ."=". 'dwf';           // if svg_js_creation_cvheadless, then make a dwf conversion first, after that apply Painter

					  	}
					  	else{

							// here we check if for all other parameters in case of svg_js_creation_cvheadless
							if ($converter == 'AutoXchange AX2011' && $parameters[$i]['paramName']!= 'f' && $json_request['action'] == 'svg_js_creation_cvheadless'){

								if ($parameters[$i]['paramName']== 's' || $parameters[$i]['paramName']== 'lw'){

									$param_string_painter = $param_string_painter . " -" . $parameters[$i]['paramName'] ."=". $parameters[$i]['paramValue'];            ;

								}
								else{

									$param_string = $param_string . " -" . $parameters[$i]['paramName'] ."=". $parameters[$i]['paramValue'];            ;
								}

							}
							else{  // general case for creating the parameter string!!

								if ($parameters[$i]['paramName'] == 'xpath') $add_xpath = false;  // we are not using the config xpath, instead we use the one in the parameters

								if ($parameters[$i]['paramName'] == 'layout'){

									$param_string = $param_string . " -" . $parameters[$i]['paramName'] ."=\"". $parameters[$i]['paramValue'] ."\""     ;

								}
								else {
									$param_string = $param_string . " -" . $parameters[$i]['paramName'] ."=". $parameters[$i]['paramValue'];            ;
								}
							}


							//	$param_string = $param_string . " -" . $parameters[$i]['paramName'] ."=". $parameters[$i]['paramValue'];            ;

					  	}

					  }

				}
				else{
					// there is only a param
					$param_string = $param_string . " -" . $parameters[$i]['paramName'] ;            ;
				}
			}
			else {
			// the parameter is empty, do nothing
			}

			// find the extension of the output file

			if ($parameters[$i]['paramName'] == 'f'){

				if ($converter == 'AutoXchange AX2011' && $parameters[$i]['paramName']== 'f' && $json_request['action'] == 'svg_js_creation_cvheadless'){

					$output_file_extension = 'dwf';       // we need to create a dwf file before passing over to Painter

				}
				else{

					$output_file_extension = $parameters[$i]['paramValue'];

				}
			}

		}

if ($debug)	echo "\$param_string: $param_string\n";

		// fetch the input file   - dependent on where it originates
 		$file_content = '';



 		if ($contenttype == 'file'){

			$pos = strpos($contentlocation, 'http');
			if ($pos !== false) {
				if ($pos == 0){
					$contentlocation = str_replace(' ', '%20', $contentlocation);
				}
			}

			if ($contentusername == '' || $contentpassword == ''  ){

				$file_content = file_get_contents($contentlocation);
			}
			else{
				$parts = explode("//", $contentstream);

				$call_with_argument = $parts[0] . "//" . $contentusername .":" . $contentpassword . "@" . $parts[1];

				$file_content = file_get_contents($call_with_argument);
			}

		}

 		if ($contenttype == 'embedded'){
 			$file_content = base64_decode($embeddedcontent);
		}


 		if ($contenttype == 'stream'){


			$pos = strpos($contentstream, 'http');
			if ($pos !== false) {
				if ($pos == 0){
					$contentstream = str_replace(' ', '%20', $contentstream);
				}
			}

			if ($contentusername == '' || $contentpassword == ''  ){


				$call_with_argument = $contentstream ."?userLabel=" . $userlabel;

				//echo " 1 here we call a stream:  $call_with_argument \n";

				$file_content = file_get_contents($call_with_argument, true);


			}
			else{

				$parts = explode("//", $contentstream);

				$call_with_argument = $parts[0] . "//" . $contentusername .":" . $contentpassword . "@" . $parts[1] ."?userLabel=" . $userlabel;

				//echo " 2 here we call a stream:  $call_with_argument \n";

				$file_content = file_get_contents($call_with_argument, true);

			}
		}




//if ($debug)	echo "\$file_content: $file_content\n";

		// make a random number and add the extension of the input file

		$temp_file_name = rand();

		$fullPath	 =  $fileLocation  . 'f' . $temp_file_name . '.' . strtolower($contentformat) ;


if ($debug)	 echo "\$fullPath: $fullPath \n";


		if ($fd = fopen ($fullPath, "w+")) {
			fwrite($fd, $file_content);
			fclose ($fd);
if ($debug)	echo "in creating file\n";
		}

if ($debug)	echo "\$fullPath: $fullPath\n";

		// build the command line
		$command_line = "";


if ($debug)	echo "\$converter_list: $converter_list\n";

		// make a loop over converters, find the executable and location
		$engine_path = "";
		$max_conv = sizeof($converter_list);

if ($debug)	 "\$max_conv: $max_conv\n";

		// Authentication - access right
		// if guest, then swap to DEMO conversion engine
		if ($demo_mode == TRUE){

			$converter = $converter . " DEMO";                          // here we possibly need a better redirection scheme
		}



		for ($i = 0; $i < $max_conv; $i++) {
			if ($converter_list[$i]['converter'] == $converter &&  $converter_list[$i]['version'] == $version){

				$engine_path = $converter_list[$i]['location'] . $converter_list[$i]['executable'];
				$ld_lib_path = $converterLocation . ':' . $converterLocation . '/ax2011' ;   // we use the lib location based on engine location

			}
			else {
			// do nothing
			}

		}


if ($debug)	 "\$engine_path: $engine_path\n";

		$command_line =	$engine_path;


		// add input file

//		$command_line = $command_line . " -i=" . $home_dir . '/' . $fullPath;
		$command_line = $command_line . " -i=" . $fullPath;

		// add output file

		$outputFile	 =  $fileLocation  . 'f' . $temp_file_name . '.' . $output_file_extension;

		$command_line = $command_line . " -o=" . $outputFile;


		// add parameters

		$command_line = $command_line . " " . $param_string;

		for ($i = 0; $i < $max_conv; $i++) {
			if ($converter_list[$i]['converter'] == $converter &&  $converter_list[$i]['version'] == $version){

				if (empty($converter_list[$i]['axpathExeOnly'])){
				    /* axpath is empty */
				}
				else{
					$command_line = $command_line . " -axpath=" . $converter_list[$i]['axpathExeOnly'];
				}


				$command_line = $command_line . " -lpath=" . $licenseLocation . '/'  ;

				if ($add_xpath)
					$command_line = $command_line  . " -xpath=" . $xpathLocation . '/' ;    // we use the config xpath if no xpath is added through parameters

			}
			else {
			// do nothing
			}
		}

		if ($demo_mode == TRUE){

			$command_line = $command_line . " -demo";

		}



if ($debug) echo "\$command_line: $command_line XXXXXXX\n";


		 $saved = getenv("LD_LIBRARY_PATH");
		 if ($saved) { $ld_lib_path .= ":$saved"; }           // append old paths if any
		 putenv("LD_LIBRARY_PATH=$ld_lib_path");              // set new value

$newenv = getenv("LD_LIBRARY_PATH");


if ($debug)	echo "this is what we get: $newenv \n";



		 $new_stuff = getenv("LD_LIBRARY_PATH");
if ($debug)	echo "LD_LIBRARY_PATH=$new_stuff  \n";


//		 $rep_sys = system($command_line, $retval);                    	// do system command;
//		echo "system= $rep_sys  return val = $retval \n";
//		 $rep_sys = system('ls -l', $retval);                    	// do system command;
//
//		echo "system= $rep_sys  return val = $retval \n";


		$out = array();

// we want to increase the execution time for time consuming conversions
// 3 min is the maximum
set_time_limit(180);



// if the content file is of type DWF and the process is svg_js_creation_cvheadless, then we do not call conversion
// we pass the input dwf file directly over to CV headless and painter

		if ( $json_request['action'] == 'svg_js_creation_cvheadless' && ( $contentformat == 'DWF' || $contentformat == 'dwf'  )){

			$cp_command_line = 'mv ./files/f' . $temp_file_name . '.' . $contentformat . ' ./files/f' . $temp_file_name . '.dwf' ;
			exec($cp_command_line, $out, $return1);

			// echo " \n rename the file to the converter output file \n";

		}
		else{  // call the converter

			exec( $command_line, $out, $return1);


if ($debug) echo " exec out " .$out;
if ($debug) echo " exec return1 ". $return1;

			// clean out originating file + temp w2d file (if present)
			//$file_1 = $home_dir. '/' . $fullPath;
			$file_1 = $fullPath;


if ($debug) echo "  unlink1 " . $file_1;


		if (!$debug)
			if (file_exists($file_1)){
				unlink($file_1);
			}


			$file_1 = $fileLocation  . 'f' . $temp_file_name . '_ac1024.dwg';
		if (!$debug)
			if (file_exists($file_1)){
				unlink($file_1);
			}

if ($debug) echo " unlink2 " . $file_1;


	//echo  " \$output_file_extension = $output_file_extension \n";

			if ($output_file_extension == 'dwf' || $output_file_extension == 'DWF'){
				$file_2	 =  $home_dir . $fileLocation  . 'f' . $temp_file_name . '.w2d';

				if (file_exists($file_2)){
					unlink($file_2);
				}

				// here we need to make a loop an remove all w2d files if conversion is done with -vn=*ALL*

			}


		}



//		echo "return1= $return1 ";
//		echo "out= $out ";


		putenv("LD_LIBRARY_PATH=$saved");           	// restore old value
		$cont_loc = $httpHost . "/" . $outputFile ;


		$embed_cont = "";




// if svg_js_creation_cvheadless, take the dwf file, run it through painter,to produce three new .js files
// delete the dwf file after use.

		if ($json_request['action'] == 'svg_js_creation_cvheadless'){


// first create a new text based dwf file which has been through headlessCV -


// set up the call to headless CV

			$cv_codebase= "/home/cadviewer/tms-restful-api/cv_headless/";
			$cv_classpath = "./cv_headless";

			$headless_command_line = "sh ./cv_headless/callCVheadless.sh " .  $cv_codebase . " " .  $home_dir . $outputFile . " " . $home_dir . $fileLocation  . 'fj' . $temp_file_name . '.' . $output_file_extension;

// echo " ZZZ $headless_command_line ZZZZZ \n";

// echo		shell_exec($headless_command_line);

			shell_exec($headless_command_line);


// echo "  $headless_command_line \n";

// set up the call to painter

			$building_data_identifier = 'BUILDING_DATA_IDENTIFIER';
			$floor = 'FLOOR';

//   -ext parameter added

			$js_command_line = "./converters/painter_L64_01_32 " . $home_dir . $fileLocation  . 'fj' . $temp_file_name . '.' . $output_file_extension ." ". $param_string_painter ." -ext -bldg=" . $building_data_identifier ." -floor=" . $floor;


// echo "  $js_command_line \n";

			exec($js_command_line, $out, $return1);

// echo "  $return1 \n";
// echo "  $out \n";

			// rename $temp_file_name .js file to -full.js


			$cp_command_line = 'mv ./files/fj' . $temp_file_name . '.js ./files/fj' . $temp_file_name . '-full.js' ;

			exec($cp_command_line, $out, $return1);


			$rm_command_line = 'rm ./files/fj' . $temp_file_name . '.js';

			exec($rm_command_line, $out, $return1);


//echo "  $cp_command_line \n";
//echo "  $rm_command_line \n";

			// copy over base-DB.js into  $temp_file_name.js


			$fP1 = $fileLocation  .'/fj' . $temp_file_name . '.js';
			$baseDB = './cv_headless/base-DB.js';
			$file_content1 = file_get_contents($baseDB);

	//echo "  $file_content1 XXXX  \n";

			if ($fd1 = fopen ($fP1, "w")) {
				fwrite($fd1, $file_content1);
				fclose ($fd1);
			}


			$old_cont_file = $home_dir . $outputFile;

			if (file_exists($old_cont_file)){
				unlink($old_cont_file);
			}

			$old_cont_file = $home_dir . $fileLocation  . 'fj' . $temp_file_name . '.' . $output_file_extension;

			// we do not yet unlink the CV Headless DWF file, as both CV and Painter needs improvements
			if (file_exists($old_cont_file)){
//				unlink($old_cont_file);
			}

		}


	$return1 = 'E' . $return1;


// set up how the content is responded  , json_request['action'] of type conversion and data_extraction

		if ( $contentresponse == 'file'){
			$embed_cont = "";

		}

		if ( $contentresponse == 'embedded'){
			$cont_loc = "";
			$cont_file = $home_dir . $outputFile;
 			$file_content_conv = file_get_contents($cont_file);
			$embed_cont = base64_encode($file_content_conv);

			// unlink content file as it is now encoded into the response
			unlink($cont_file);

		}

		if ( $contentresponse == 'stream'){
			$embed_cont = "";
			$cont_loc = $stream_response_cgi . "?fileTag=f" . $temp_file_name . "&Type=" . $output_file_extension;
		}



		// array with response - for type "file" and "stream" - below we rewrite it if of type "embedded"
		$conversion_response = array( "completedAction" => $json_request['action'],
									  "errorCode" => $return1,
									  "converter" => $converter,
									  "version" => $version,
									  "userLabel" => $userlabel,
									  "contentResponse" => $contentresponse,
									  "contentLocation" => $cont_loc);


		if ( $contentresponse == 'stream'){

			$conversion_response = array( "completedAction" => $json_request['action'],
										  "errorCode" => $return1,
										  "converter" => $converter,
										  "version" => $version,
										  "userLabel" => $userlabel,
										  "contentResponse" => $contentresponse,
										  "contentStream" => $cont_loc);
		}





		if ( $contentresponse == 'embedded'){

			$conversion_response = array( "completedAction" => $json_request['action'],
										  "errorCode" => $return1,
										  "converter" => $converter,
										  "version" => $version,
										  "userLabel" => $userlabel,
										  "contentResponse" => $contentresponse,
										  "embeddedContent" => $embed_cont);

		}






// set up how the content is responded  , json_request['action'] of type svg_js_creation_cvheadless
// based on CV headless

		if ( $json_request['action'] == 'svg_js_creation_cvheadless' ){


			if ( $contentresponse == 'file'){
				$embed_cont = "";
				$cont_loc1= $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-full.js';
				$cont_loc2= $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-nodes.js';
				$cont_loc3= $home_dir . $fileLocation  . 'fj' . $temp_file_name . '.js';
				$cont_loc4= $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-thumb.js';
			}


			if ( $contentresponse == 'embedded'){
				$cont_file = $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-full.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont1 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-nodes.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont2 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $home_dir . $fileLocation  . 'fj' . $temp_file_name . '.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont3 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $home_dir . $fileLocation  . 'fj' . $temp_file_name . '-thumb.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont4 = base64_encode($file_content_conv);
				unlink($cont_file);



			}

			if ( $contentresponse == 'stream'){
				$embed_cont = "";
				$cont_loc1 = $stream_response_cgi . "?fileTag=" . 'fj' . $temp_file_name . '-full' . "&Type=" . "js";

				$cont_loc2 = $stream_response_cgi . "?fileTag=" . 'fj' . $temp_file_name . '-nodes' . "&Type=" . "js";

				$cont_loc3 = $stream_response_cgi . "?fileTag=" . 'fj' . $temp_file_name . "&Type=" . "js";

				$cont_loc4 = $stream_response_cgi . "?fileTag=" . 'fj' . $temp_file_name . '-thumb' . "&Type=" . "js";


			}



			// array with response - for type "file" and "stream" - below we rewrite it if of type "embedded"
			$conversion_response = array( "completedAction" => $json_request['action'],
										  "errorCode" => $return1,
										  "converter" => $converter,
										  "version" => $version,
										  "userLabel" => $userlabel,
										  "contentResponse" => $contentresponse,
										  "contentLocationGraphics" => $cont_loc1,
										  "contentLocationNodes" => $cont_loc2,
										  "contentLocationData" => $cont_loc3,
										  "contentLocationThumb" => $cont_loc4);


			if ( $contentresponse == 'stream'){

				$conversion_response = array( "completedAction" => $json_request['action'],
											  "errorCode" => $return1,
											  "converter" => $converter,
											  "version" => $version,
											  "userLabel" => $userlabel,
											  "contentResponse" => $contentresponse,
											  "contentStreamGraphics" => $cont_loc1,
											  "contentStreamNodes" => $cont_loc2,
											  "contentStreamData" => $cont_loc3,
											  "contentStreamThumb" => $cont_loc4);
			}




			if ( $contentresponse == 'embedded'){

				$conversion_response = array( "completedAction" => $json_request['action'],
											  "errorCode" => $return1,
											  "converter" => $converter,
											  "version" => $version,
											  "userLabel" => $userlabel,
											  "contentResponse" => $contentresponse,
											  "embeddedContentGraphics" => $embed_cont1,
											  "embeddedContentNodes" => $embed_cont2,
											  "embeddedContentData" => $embed_cont3,
											  "contentStreamThumb" => $embed_loc4);

			}


		}





// set up how the content is responded  , json_request['action'] of type svg_js_creation
// based on AX2015/AX2011  -f=js conversion

		if ( $json_request['action'] == 'svg_js_creation' ){


			if ( $contentresponse == 'file'){
				$embed_cont = "";
				$cont_loc1= $fileLocationUrl  . 'f' . $temp_file_name . '-full.js';
				$cont_loc2= $fileLocationUrl  . 'f' . $temp_file_name . '-nodes.js';
				$cont_loc3= $fileLocationUrl  . 'f' . $temp_file_name . '.js';
				$cont_loc4= $fileLocationUrl  . 'f' . $temp_file_name . '-thumb.js';
			}


			if ( $contentresponse == 'embedded'){
				$cont_file = $fileLocation  . 'f' . $temp_file_name . '-full.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont1 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $fileLocation  . 'f' . $temp_file_name . '-nodes.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont2 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $fileLocation  . 'f' . $temp_file_name . '.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont3 = base64_encode($file_content_conv);
				unlink($cont_file);

				$cont_file = $fileLocation  . 'f' . $temp_file_name . '-thumb.js';
				$file_content_conv = file_get_contents($cont_file);
				$embed_cont4 = base64_encode($file_content_conv);
				unlink($cont_file);



			}

			if ( $contentresponse == 'stream'){
				$embed_cont = "";
				$cont_loc1 = $stream_response_cgi . "?fileTag=" . 'f' . $temp_file_name . '-full' . "&Type=" . "js";

				$cont_loc2 = $stream_response_cgi . "?fileTag=" . 'f' . $temp_file_name . '-nodes' . "&Type=" . "js";

				$cont_loc3 = $stream_response_cgi . "?fileTag=" . 'f' . $temp_file_name . "&Type=" . "js";

				$cont_loc4 = $stream_response_cgi . "?fileTag=" . 'f' . $temp_file_name . '-thumb' . "&Type=" . "js";


			}



			// array with response - for type "file" and "stream" - below we rewrite it if of type "embedded"
			$conversion_response = array( "completedAction" => $json_request['action'],
										  "errorCode" => $return1,
										  "converter" => $converter,
										  "version" => $version,
										  "userLabel" => $userlabel,
										  "contentResponse" => $contentresponse,
										  "contentLocationGraphics" => $cont_loc1,
										  "contentLocationNodes" => $cont_loc2,
										  "contentLocationData" => $cont_loc3,
										  "contentLocationThumb" => $cont_loc4);


			if ( $contentresponse == 'stream'){

				$conversion_response = array( "completedAction" => $json_request['action'],
											  "errorCode" => $return1,
											  "converter" => $converter,
											  "version" => $version,
											  "userLabel" => $userlabel,
											  "contentResponse" => $contentresponse,
											  "contentStreamGraphics" => $cont_loc1,
											  "contentStreamNodes" => $cont_loc2,
											  "contentStreamData" => $cont_loc3,
											  "contentStreamThumb" => $cont_loc4);
			}




			if ( $contentresponse == 'embedded'){

				$conversion_response = array( "completedAction" => $json_request['action'],
											  "errorCode" => $return1,
											  "converter" => $converter,
											  "version" => $version,
											  "userLabel" => $userlabel,
											  "contentResponse" => $contentresponse,
											  "embeddedContentGraphics" => $embed_cont1,
											  "embeddedContentNodes" => $embed_cont2,
											  "embeddedContentData" => $embed_cont3,
											  "contentStreamThumb" => $embed_loc4);

			}


		}




		$conversion_resp = _json_encode($conversion_response);
		$general_response = $conversion_resp;

	}




	// Format data into a JSON response
	$json_response = json_encode($general_response);


	// SEND BACK RESPONSE!!!!!!

	// Deliver formatted data, if no errors and if authentication is correct
	if (($wrong_post_format == 0)  && ($authentication_success == TRUE)){

		//echo "XXX here";


		// echo $json_response;    - removed 2016-01-28
		// 2016-01-28  here we need to wrap the json encoded resonse into the callback method


		// if jsonp then prepend callback, if standard post do not
		if ($post_request_flag){
			// Set HTTP Response Content Type
				header('Content-Type: application/json; charset=utf-8');
  			echo $json_response;
		}
		else
    		echo $callback.'(' . $json_response . ')';

		exit;
	}




	// hereafter auxillary methods

	function _json_encode($val)
	{
	    if (is_string($val)) return '"'.addslashes($val).'"';
	    if (is_numeric($val)) return $val;
	    if ($val === null) return 'null';
	    if ($val === true) return 'true';
	    if ($val === false) return 'false';

	    $assoc = false;
	    $i = 0;
	    foreach ($val as $k=>$v){
	        if ($k !== $i++){
	            $assoc = true;
	            break;
	        }
	    }
	    $res = array();
	    foreach ($val as $k=>$v){
	        $v = _json_encode($v);
	        if ($assoc){
	            $k = '"'.addslashes($k).'"';
	            $v = $k.':'.$v;
	        }
	        $res[] = $v;
	    }
	    $res = implode(',', $res);
	    return ($assoc)? '{'.$res.'}' : '['.$res.']';
	}




?>